package md

type GetPublicPlatoonBasicResp struct {
	IsOpen                     int `json:"is_open"`
	OriginatorUid              int `json:"originator_uid"`
	SeveralTimes               int `json:"several_times"`
	SeveralRows                int `json:"several_rows"`
	SystemPunishReplace        int `json:"system_punish_replace"`
	SystemPunishReplaceValue   int `json:"system_punish_replace_value"`
	IsSelfActiveGetTeamRevenue int `json:"is_self_active_get_team_revenue"`
}

type UpdatePublicPlatoonBasicReq struct {
	IsOpen                     int `json:"is_open"`
	OriginatorUid              int `json:"originator_uid"`
	SeveralTimes               int `json:"several_times"`
	SeveralRows                int `json:"several_rows"`
	SystemPunishReplace        int `json:"system_punish_replace"`
	SystemPunishReplaceValue   int `json:"system_punish_replace_value"`
	IsSelfActiveGetTeamRevenue int `json:"is_self_active_get_team_revenue"`
}

type GetRelationshipMapReq struct {
	Phone int   `json:"phone"`
	Uid   int64 `json:"uid"`
}

type RelationshipMap struct {
	AvatarUrl string            `json:"avatar_url"`
	Phone     string            `json:"phone"`
	Nickname  string            `json:"nickname"`
	Uid       int64             `json:"uid"`
	Pid       int64             `json:"pid"`
	Level     int               `json:"level"`
	Position  int64             `json:"position"`
	SystemID  int               `json:"system_id"`
	Son       []RelationshipMap `json:"son"`
}

type RelationshipMapResp struct {
	Map          RelationshipMap           `json:"map"`
	BasicSetting GetPublicPlatoonBasicResp `json:"basicSetting"`
	SearchUid    string                    `json:"searchUid"`
}

type FindUserRelationshipMapReq struct {
	Uid int64 `json:"uid"`
}

type FindSubUserRelationshipMapReq struct {
	Uid int64 `json:"uid"`
}

type ExchangeUserPositionReq struct {
	Position1 int64 `json:"position_1"`
	Position2 int64 `json:"position_2"`
}

type TreeNode struct {
	AvatarURL string      `json:"avatar_url"`
	Phone     string      `json:"phone"`
	Nickname  string      `json:"nickname"`
	Uid       int64       `json:"uid"`
	PID       int64       `json:"pid"`
	Position  int64       `json:"position"`
	SystemID  int64       `json:"system_id"`
	Level     int         `json:"level"`
	Son       []*TreeNode `json:"son"`
}
